Back out newly introduced EF_PROTECT_FREE.
[xfstests-dev.git] / common.rc
1 ##/bin/sh
2
3 #
4 # Copyright (c) 2000 Silicon Graphics, Inc.  All Rights Reserved.
5
6 # This program is free software; you can redistribute it and/or modify it
7 # under the terms of version 2 of the GNU General Public License as
8 # published by the Free Software Foundation.
9
10 # This program is distributed in the hope that it would be useful, but
11 # WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
13
14 # Further, this software is distributed without any warranty that it is
15 # free of the rightful claim of any third person regarding infringement
16 # or the like.  Any license provided herein, whether implied or
17 # otherwise, applies only to this software file.  Patent licenses, if
18 # any, provided herein do not apply to combinations of this program with
19 # other software, or any other product whatsoever.
20
21 # You should have received a copy of the GNU General Public License along
22 # with this program; if not, write the Free Software Foundation, Inc., 59
23 # Temple Place - Suite 330, Boston MA 02111-1307, USA.
24
25 # Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
26 # Mountain View, CA  94043, or:
27
28 # http://www.sgi.com 
29
30 # For further information regarding this notice, see: 
31
32 # http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
33 #
34
35 # we need common.config
36 if ! . ./common.config
37 then
38     echo "$iam: failed to source common.config"
39     exit 1
40 fi
41
42 # awk
43 AWK_PROG=awk
44
45 # ps
46 PS_HAVE_BSD=false
47 PS_ALL_FLAGS=-efw
48
49 # host os
50 PLATFORM=linux
51
52 # extra parameters for fsstress
53 FSSTRESS_AVOID="-f resvsp=0 -f unresvsp=0"
54
55 # env variables for mem checking
56 #EF_PROTECT_FREE=1 # efence
57 #export EF_PROTECT_FREE
58 # Not used because we get weird errors of form:
59 # ElectricFence Exiting: mmap() failed: Cannot allocate memory
60
61 export AWK_PROG PS_HAVE_BSD PS_ALL_FLAGS PLATFORM
62
63 # we override mount so we can specify mount options
64
65 mount()
66 {
67     case "$*"
68     in
69         *remount*)
70             /bin/mount $*
71             ;;
72         *ext2*)
73             /bin/mount $*
74             ;;
75         *xfs*)
76             /bin/mount $* $MOUNT_OPTIONS
77             ;;
78         *)
79             /bin/mount $*
80             ;;
81     esac
82 }
83
84 #
85
86 _get_pids_by_name()
87 {
88     if [ $# -ne 1 ]
89     then
90         echo "Usage: _get_pids_by_name process-name" 1>&2
91         exit 1
92     fi
93
94     # Algorithm ... all ps(1) variants have a time of the form MM:SS or
95     # HH:MM:SS before the psargs field, use this as the search anchor.
96     #
97     # Matches with $1 (process-name) occur if the first psarg is $1
98     # or ends in /$1 ... the matching uses sed's regular expressions,
99     # so passing a regex into $1 will work.
100
101     ps $PS_ALL_FLAGS \
102     | sed -n \
103         -e 's/$/ /' \
104         -e 's/[         ][      ]*/ /g' \
105         -e 's/^ //' \
106         -e 's/^[^ ]* //' \
107         -e "/[0-9]:[0-9][0-9]  *[^ ]*\/$1 /s/ .*//p" \
108         -e "/[0-9]:[0-9][0-9]  *$1 /s/ .*//p"
109 }
110
111 # fqdn for localhost
112 #
113 _get_fqdn()
114 {
115     host=`hostname`
116     nslookup $host | $AWK_PROG '{ if ($1 == "Name:") print $2 }'
117 }
118
119 # fix malloc libs output
120 #
121 _fix_malloc()
122 {
123     # filter out the Electric Fence notice
124     perl -e '
125         while (<>) {
126             if (defined $o && /^\s+Electric Fence/) {
127                 chomp($o);
128                 print "$o";
129                 undef $o;
130                 next;
131             }
132             print $o if (defined $o);
133
134             $o=$_;
135         }
136         print $o if (defined $o);
137     '
138 }
139
140 # check if run as root
141 #
142 _need_to_be_root()
143 {
144     id=`id | sed -e 's/(.*//' -e 's/.*=//'`
145     if [ "$id" -ne 0 ]
146     then
147         echo "Arrgh ... you need to be root (not uid=$id) to run this test"
148         exit 1
149     fi
150 }
151
152
153 #
154 # _df_device : get an IRIX style df line for a given device 
155 #
156 #       - returns "" if not mounted
157 #       - returns fs type in field two (ala IRIX)
158 #       - joins line together if split by fancy df formatting
159 #       - strips header etc
160 #
161
162 _df_device()
163 {
164     if [ $# -ne 1 ]
165     then
166         echo "Usage: _df_device device" 1>&2
167         exit 1
168     fi
169     
170     df -T 2>/dev/null | $AWK_PROG -v what=$1 '
171         match($1,what) && NF==1 { 
172             v=$1
173             getline
174             print v, $0
175             exit
176         }
177         match($1,what) {
178             print
179             exit
180         }
181     '
182 }
183
184 #
185 # _df_dir : get an IRIX style df line for device where a directory resides
186 #
187 #       - returns fs type in field two (ala IRIX)
188 #       - joins line together if split by fancy df formatting
189 #       - strips header etc
190 #
191
192 _df_dir()
193 {
194     if [ $# -ne 1 ]
195     then
196         echo "Usage: _df_dir device" 1>&2
197         exit 1
198     fi
199     
200     df -T $1 2>/dev/null | $AWK_PROG -v what=$1 '
201         NR == 2 && NF==1 { 
202             v=$1
203             getline 
204             print v, $0;
205             exit 0
206         }
207         NR == 2 {
208             print;
209             exit 0
210         }
211         {}
212     '
213     # otherwise, nada
214 }
215
216 # return percentage used disk space for mounted device
217
218 _used()
219 {
220     if [ $# -ne 1 ]
221     then
222         echo "Usage: _used device" 1>&2
223         exit 1
224     fi
225     
226     _df_device $1 | $AWK_PROG '{ sub("%", "") ; print $6 }'
227 }
228
229 # return the FS type of a mounted device
230 #
231 _fs_type()
232 {
233     if [ $# -ne 1 ]
234     then
235         echo "Usage: _fs_type device" 1>&2
236         exit 1
237     fi
238     
239     _df_device $1 | $AWK_PROG '{ print $2 }'
240 }
241
242 # return the FS mount options of a mounted device
243 #
244 _fs_options()
245 {
246     if [ $# -ne 1 ]
247     then
248         echo "Usage: _fs_options device" 1>&2
249         exit 1
250     fi
251     
252     $AWK_PROG -v dev=$1 '
253         match($1,dev) { print $4 }
254     ' </proc/mounts
255     
256 }
257
258 # returns device number if a file is a block device
259 #
260 _is_block_dev()
261 {
262     if [ $# -ne 1 ]
263     then
264         echo "Usage: _is_block_dev dev" 1>&2
265         exit 1
266     fi
267     
268     [ -b $1 ] && src/lstat64 $1 | $AWK_PROG '/Device type:/ { print $9 }'
269 }
270
271 # Do a command, log it to $seq.full, optionally test return status
272 # and die if command fails. If called with one argument _do executes the
273 # command, logs it, and returns its exit status. With two arguments _do
274 # first prints the message passed in the first argument, and then "done"
275 # or "fail" depending on the return status of the command passed in the
276 # second argument. If the command fails and the variable _do_die_on_error
277 # is set to "always" or the two argument form is used and _do_die_on_error
278 # is set to "message_only" _do will print an error message to
279 # $seq.out and exit.
280
281 _do()
282 {
283   if [ $# -eq 1 ]; then
284     _cmd=$1
285   elif [ $# -eq 2 ]; then
286     _note=$1
287     _cmd=$2
288     echo -n "$_note... "
289   else
290     echo "Usage: _do [note] cmd" 1>&2
291     status=1; exit
292   fi
293
294   (eval "echo '---' \"$_cmd\"") >>$seq.full
295   (eval "$_cmd") >$tmp._out 2>&1; ret=$?
296   cat $tmp._out | _fix_malloc >>$seq.full
297   if [ $# -eq 2 ]; then
298     if [ $ret -eq 0 ]; then
299       echo "done"
300     else
301       echo "fail"
302     fi
303   fi
304   if [ $ret -ne 0  ] \
305      && [ "$_do_die_on_error" = "always" \
306          -o \( $# -eq 2 -a "$_do_die_on_error" = "message_only" \) ]
307   then
308       [ $# -ne 2 ] && echo
309       eval "echo \"$_cmd\" failed \(returned $ret\): see $seq.full"
310       status=1; exit
311   fi
312
313   return $ret
314 }
315
316 # bail out, setting up .notrun file
317
318 _notrun()
319 {
320     echo "$*" >$seq.notrun
321     echo "$seq not run: $*"
322     status=0
323     exit
324 }
325
326 # just plain bail out
327
328 _fail()
329 {
330     echo "$*" | tee -a $seq.full
331     echo "(see $seq.full for details)"
332     status=1
333     exit 1
334 }
335
336 # this test needs a scratch partition - check we're ok & unmount it
337
338 _require_scratch()
339 {
340
341     if [ -z "$SCRATCH_DEV" -o "`_is_block_dev $SCRATCH_DEV`" = "" ]
342     then
343         _notrun "this test requires a valid \$SCRATCH_DEV"
344     fi
345     
346     if [ "`_is_block_dev $SCRATCH_DEV`" = "`_is_block_dev $TEST_DEV`" ]
347     then
348         _notrun "this test requires a valid \$SCRATCH_DEV"
349     fi
350     
351     # mounted?
352     if mount | grep -q $SCRATCH_DEV
353     then 
354         # if it's mounted, make sure its on $SCRATCH_MNT
355         if ! mount | grep $SCRATCH_DEV | grep -q $SCRATCH_MNT
356         then 
357             echo "\$SCRATCH_DEV is mounted but not on \$SCRATCH_MNT - aborting"
358             exit 1
359         fi
360         
361         # and then unmount it
362     
363         if ! umount $SCRATCH_DEV
364         then
365             echo "failed to unmount $SCRATCH_DEV"
366             exit 1
367         fi
368     fi
369     
370     # should be ok now
371
372 }
373
374 # this test needs a logdev 
375
376 _require_logdev()
377 {
378     if [ -z "$SCRATCH_LOGDEV" -o ! -b "$SCRATCH_LOGDEV" ]
379     then
380         _notrun "This test requires a valid \$SCRATCH_LOGDEV" 
381     fi
382 }
383
384 # this test requires loopback device support
385
386 _require_loop()
387 {
388     if grep loop /proc/devices >/dev/null 2>&1
389     then
390         :
391     else
392         _notrun "This test requires loopback device support"
393     fi
394 }
395
396
397 # check that a FS is mounted as XFS. if so, return mount point
398 #
399 _xfs_mounted()
400 {
401     if [ $# -ne 1 ]
402     then
403         echo "Usage: _xfs_mounted device" 1>&2
404         exit 1
405     fi
406     
407     device=$1
408     
409     if mount | grep $device | $AWK_PROG '
410         /type xfs/  { print $3 ; exit 0 }
411         END         { exit 1 }
412     '
413     then
414         echo "_xfs_mounted: $device is not a mounted XFS FS"
415         exit 1
416     fi
417 }
418
419 # remount a FS to a new mode (ro or rw)
420 #
421
422 _remount()
423 {
424     if [ $# -ne 2 ]
425     then
426         echo "Usage: _remount device ro/rw" 1>&2
427         exit 1
428     fi
429     device=$1
430     mode=$2
431     
432     if ! mount -o remount,$mode $device
433     then
434         echo "_remount: failed to remount filesystem on $device as $mode"
435         exit 1
436     fi
437     
438     # we might like to check here later
439     #options=`_fs_options $device`
440
441 }
442
443 # run xfs_check on a FS. 
444 #
445 # if the filesystem is mounted, it's either remounted ro before being
446 # checked or it's unmounted and then remounted
447 #
448
449 USE_REMOUNT=0
450
451 _check_fs()
452 {
453     if [ $# -ne 1 ]
454     then
455         echo "Usage: _check_fs device" 1>&2
456         exit 1
457     fi
458     
459     device=$1
460     type=`_fs_type $device`
461     ok=1
462     
463     if [ "$type" = "xfs" ]
464     then
465         # mounted... 
466         
467         if [ $USE_REMOUNT -eq 0 ]
468         then
469             mountpoint=`_xfs_mounted $device`
470             umount $device
471         else
472             _remount $device ro
473         fi
474     fi
475
476     xfs_logprint -t $device 2>&1 | tee $tmp.fs_check | grep -q "<CLEAN>"
477     if [ $? -ne 0 ]
478     then
479         echo "_check_fs: filesystem on $device has dirty log (see $seq.full)"
480         
481         echo "_check_fs: filesystem on $device has dirty log"   >>$seq.full
482         echo "*** xfs_logprint -t output ***"                   >>$seq.full
483         cat $tmp.fs_check                                       >>$seq.full
484         echo "*** end xfs_logprint output"                      >>$seq.full
485         
486         ok=0
487     fi
488         
489     
490     xfs_check $device 2>&1 | _fix_malloc >$tmp.fs_check 
491     if [ -s $tmp.fs_check ]
492     then
493         echo "_check_fs: filesystem on $device is inconsistent (c) (see $seq.full)"
494         
495         echo "_check_fs: filesystem on $device is inconsistent" >>$seq.full
496         echo "*** xfs_check output ***"                         >>$seq.full
497         cat $tmp.fs_check                                       >>$seq.full
498         echo "*** end xfs_check output"                         >>$seq.full
499         
500         ok=0
501     fi
502     
503     if ! xfs_repair -n $device >$tmp.fs_check 2>&1
504     then
505         echo "_check_fs: filesystem on $device is inconsistent (r) (see $seq.full)"
506         
507         echo "_check_fs: filesystem on $device is inconsistent" >>$seq.full
508         echo "*** xfs_repair -n output ***"                     >>$seq.full
509         cat $tmp.fs_check | _fix_malloc                         >>$seq.full
510         echo "*** end xfs_repair output"                        >>$seq.full
511         
512         ok=0
513     fi
514     rm -f $tmp.fs_check
515     
516     if [ $ok -eq 0 ]
517     then
518         echo "*** mount output ***"                             >>$seq.full
519         mount                                                   >>$seq.full
520         echo "*** end mount output"                             >>$seq.full
521     fi
522     
523     if [ "$type" = "xfs" ]
524     then
525         # mounted... 
526         if [ $USE_REMOUNT -eq 0 ]
527         then
528             if ! mount -t xfs $device $mountpoint
529             then
530                 echo "!!! failed to remount $device on $mountpoint"
531                 ok=0
532             fi
533         else
534             _remount $device rw
535         fi
536     fi
537     
538     [ $ok -eq 0 ] && exit 1
539     return 0    
540 }
541
542 ################################################################################
543
544 [ -d /usr/bsd ] && PATH=$PATH:/usr/bsd
545 [ -d /usr/freeware/bin ] && PATH=$PATH:/usr/freeware/bin
546
547 if [ "$iam" != new ]
548 then
549
550     # make some further configuration checks here
551     
552     if [ "$TEST_DEV" = ""  ]
553     then
554         echo "common.rc: Error: \$TEST_DEV is not set"
555         exit 1
556     fi
557     
558     if [ "`_fs_type $TEST_DEV`" != "xfs" ]
559     then
560         echo "common.rc: Error: \$TEST_DEV ($TEST_DEV) is not a MOUNTED XFS filesystem"
561         df -T $TEST_DEV
562         exit 1
563     fi
564
565 fi
566
567 # check for some required biunaries on our $PATH
568 #
569 for exec in mkfs.xfs xfs_logprint xfs_check xfs_repair xfs_db
570 do
571     if which $exec >/dev/null 2>&1 
572     then
573         :
574     else
575         echo "common.rc: cannot find $exec on \$PATH=$PATH"
576         exit 1
577     fi
578 done
579
580 # make sure this script returns success
581 /bin/true